diff --git a/cpp/orm_engine/bind.cpp b/cpp/orm_engine/bind.cpp
index c3e0de7579..26c603522e 100644
--- a/cpp/orm_engine/bind.cpp
+++ b/cpp/orm_engine/bind.cpp
@@ -208,6 +779,578 @@ void register_orm_engine(nb::module_& parent) {
   m.attr("DIALECT_MYSQL") = 1;
   m.attr("DIALECT_SQLITE") = 2;
 
+  nb::class_<django::orm::QueryPlan>(m, "QueryPlan")
+      .def_static(
+          "for_simple_filter",
+          [](std::uint32_t model_id, const std::string& lookup_field,
+             bool lookup_in, nb::sequence lookup_values) -> nb::object {
+            const auto* model = registered_model(model_id);
+            if (!model || lookup_field.find("__") != std::string::npos) {
+              return nb::none();
+            }
+            auto values = native_lookup_values_from_python(
+                *model, lookup_field, lookup_in, lookup_values);
+            if (!values) {
+              return nb::none();
+            }
+            return nb::cast(
+                django::orm::QueryPlan(
+                    static_cast<django::orm::ModelId>(model_id))
+                    .with_simple_filter(
+                        lookup_field, lookup_in, std::move(*values)));
+          },
+          nb::arg("model_id"), nb::arg("lookup_field"),
+          nb::arg("lookup_in"), nb::arg("lookup_values"))
+      .def_static(
+          "for_q",
+          [](std::uint32_t model_id, nb::dict tree) -> nb::object {
+            auto node = native_q_node_from_python(model_id, tree);
+            if (!node) {
+              return nb::none();
+            }
+            return nb::cast(
+                django::orm::QueryPlan(
+                    static_cast<django::orm::ModelId>(model_id))
+                    .with_filter(std::move(*node)));
+          },
+          nb::arg("model_id"), nb::arg("tree"))
+      .def_static(
+          "for_ordering",
+          [](std::uint32_t model_id, nb::sequence names) -> nb::object {
+            const auto* model = registered_model(model_id);
+            auto ordering = strings_from_sequence(names);
+            if (!model || !validate_native_ordering(*model, ordering)) {
+              return nb::none();
+            }
+            return nb::cast(
+                django::orm::QueryPlan(
+                    static_cast<django::orm::ModelId>(model_id))
+                    .with_ordering(std::move(ordering)));
+          },
+          nb::arg("model_id"), nb::arg("names"))
+      .def_static(
+          "for_values",
+          [](std::uint32_t model_id, nb::sequence names) -> nb::object {
+            const auto* model = registered_model(model_id);
+            auto fields = strings_from_sequence(names);
+            if (!model || !validate_native_projection(*model, fields)) {
+              return nb::none();
+            }
+            return nb::cast(
+                django::orm::QueryPlan(
+                    static_cast<django::orm::ModelId>(model_id))
+                    .with_values(std::move(fields)));
+          },
+          nb::arg("model_id"), nb::arg("names"))
+      .def_static(
+          "from_simple_filter",
+          [](const std::string& lookup_field, bool lookup_in,
+             nb::sequence lookup_values) {
+            std::vector<django::orm::ParamValue> values;
+            values.reserve(nb::len(lookup_values));
+            for (nb::handle value : lookup_values) {
+              values.push_back(param_from_python(value));
+            }
+            return django::orm::QueryPlan{}.with_simple_filter(
+                lookup_field, lookup_in, std::move(values));
+          },
+          nb::arg("lookup_field"), nb::arg("lookup_in"),
+          nb::arg("lookup_values"))
+      .def_static(
+          "from_q",
+          [](nb::dict tree) {
+            return django::orm::QueryPlan{}.with_filter(
+                q_node_from_python(tree));
+          },
+          nb::arg("tree"))
+      .def_static(
+          "from_ordering",
+          [](nb::sequence names) {
+            return django::orm::QueryPlan{}.with_ordering(
+                strings_from_sequence(names));
+          },
+          nb::arg("names"))
+      .def_static(
+          "from_values",
+          [](nb::sequence names) {
+            return django::orm::QueryPlan{}.with_values(
+                strings_from_sequence(names));
+          },
+          nb::arg("names"))
+      .def(
+          "with_q",
+          [](const django::orm::QueryPlan& self, nb::dict tree) -> nb::object {
+            if (!self.is_model_bound()) {
+              return nb::cast(self.with_filter(q_node_from_python(tree)));
+            }
+            auto model_id = self.model_id();
+            if (!model_id || !self.matches_model(*model_id)) {
+              return nb::none();
+            }
+            auto node = native_q_node_from_python(
+                static_cast<std::uint32_t>(*model_id), tree);
+            if (!node) {
+              return nb::none();
+            }
+            return nb::cast(self.with_filter(std::move(*node)));
+          },
+          nb::arg("tree"))
+      .def(
+          "with_ordering",
+          [](const django::orm::QueryPlan& self,
+             nb::sequence names) -> nb::object {
+            auto ordering = strings_from_sequence(names);
+            if (!self.is_model_bound()) {
+              return nb::cast(self.with_ordering(std::move(ordering)));
+            }
+            auto model_id = self.model_id();
+            const auto* model = model_id ? registered_model(*model_id) : nullptr;
+            if (!model_id || !self.matches_model(*model_id) || !model ||
+                !validate_native_ordering(*model, ordering)) {
+              return nb::none();
+            }
+            return nb::cast(self.with_ordering(std::move(ordering)));
+          },
+          nb::arg("names"))
+      .def(
+          "with_values",
+          [](const django::orm::QueryPlan& self,
+             nb::sequence names) -> nb::object {
+            auto fields = strings_from_sequence(names);
+            if (!self.is_model_bound()) {
+              return nb::cast(self.with_values(std::move(fields)));
+            }
+            auto model_id = self.model_id();
+            const auto* model = model_id ? registered_model(*model_id) : nullptr;
+            if (!model_id || !self.matches_model(*model_id) || !model ||
+                !validate_native_projection(*model, fields)) {
+              return nb::none();
+            }
+            return nb::cast(self.with_values(std::move(fields)));
+          },
+          nb::arg("names"))
+      .def("has_only_projection",
+           &django::orm::QueryPlan::has_only_projection)
+      .def("has_simple_filter", &django::orm::QueryPlan::has_simple_filter)
+      .def(
+          "simple_filter",
+          [](const django::orm::QueryPlan& self) -> nb::object {
+            for (const auto& operation : self.operations()) {
+              if (operation.kind !=
+                      django::orm::QueryPlan::OperationKind::Filter ||
+                  !operation.simple_filter) {
+                continue;
+              }
+              nb::list values;
+              for (const auto& value : operation.filter.values) {
+                values.append(param_to_python(value));
+              }
+              return nb::make_tuple(operation.lookup_field,
+                                    operation.lookup_in, values);
+            }
+            return nb::none();
+          })
+      .def(
+          "replay",
+          [](const django::orm::QueryPlan& self) {
+            nb::list replay;
+            for (const auto& operation : self.operations()) {
+              switch (operation.kind) {
+                case django::orm::QueryPlan::OperationKind::Filter:
+                  replay.append(nb::make_tuple(
+                      "filter", q_node_to_python(operation.filter)));
+                  break;
+                case django::orm::QueryPlan::OperationKind::OrderBy:
+                  replay.append(nb::make_tuple(
+                      "order_by",
+                      django::native::list_from_strings(operation.names)));
+                  break;
+                case django::orm::QueryPlan::OperationKind::Values:
+                  replay.append(nb::make_tuple(
+                      "values",
+                      django::native::list_from_strings(operation.names)));
+                  break;
+              }
+            }
+            return replay;
+          });
+
+  m.def(
+      "compile_simple_values_get",
+      [](std::uint32_t model_id, int dialect, nb::sequence field_names,
+         const std::string& lookup_field, nb::handle lookup_value,
+         std::uint64_t limit,
+         nb::handle postgres_integer_types) -> nb::object {
+        auto fields = strings_from_sequence(field_names);
+        const auto* model = registered_model(model_id);
+        auto lookup = model
+                          ? registered_native_lookup(*model, lookup_field)
+                          : std::optional<NativeLookup>{};
+        if (!model || !validate_native_projection(*model, fields) || !lookup ||
+            lookup->lookup != "exact") {
+          return nb::none();
+        }
+        const bool null_lookup = lookup_value.is_none();
+        auto prepared = direct_param_from_python(
+            lookup_value, *lookup->field, null_lookup);
+        if (!prepared) {
+          return nb::none();
+        }
+        const auto key = simple_compile_key(
+            'G', model_id, dialect, fields, lookup_field, {}, limit, 0,
+            null_lookup);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.values(fields, true, django::orm::ResultMode::ValuesList)) {
+            return std::string{};
+          }
+          const bool filtered =
+              null_lookup
+                  ? qs.filter_isnull(lookup_field, true)
+                  : qs.filter_eq(lookup_field,
+                                 django::orm::ParamValue::from_int(0));
+          if (!filtered) {
+            return std::string{};
+          }
+          qs.set_limit(limit);
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        nb::list params;
+        if (!null_lookup) {
+          params.append(param_to_python(*prepared, postgres_integer_types));
+        }
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), params);
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("field_names"),
+      nb::arg("lookup_field"), nb::arg("lookup_value"), nb::arg("limit"),
+      nb::arg("postgres_integer_types") = nb::none());
+
+  m.def(
+      "compile_simple_values_select",
+      [](std::uint32_t model_id, int dialect, nb::sequence field_names,
+         nb::sequence ordering_names, std::uint64_t limit,
+         std::uint64_t offset) -> nb::object {
+        auto fields = strings_from_sequence(field_names);
+        auto ordering = strings_from_sequence(ordering_names);
+        const auto* model = registered_model(model_id);
+        if (!model || !validate_native_projection(*model, fields) ||
+            !validate_native_ordering(*model, ordering)) {
+          return nb::none();
+        }
+        const auto key = simple_compile_key(
+            'S', model_id, dialect, fields, {}, ordering, limit, offset);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.values(fields, true, django::orm::ResultMode::ValuesList)) {
+            return std::string{};
+          }
+          for (const auto& item : ordering) {
+            bool desc = !item.empty() && item.front() == '-';
+            std::string_view name(item);
+            if (desc) {
+              name.remove_prefix(1);
+            }
+            if (name.empty() || name == "?" || !qs.order_by(name, desc)) {
+              return std::string{};
+            }
+          }
+          if (limit > 0) {
+            qs.set_limit(limit);
+          }
+          if (offset > 0) {
+            qs.set_offset(offset);
+          }
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), nb::list());
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("field_names"),
+      nb::arg("ordering_names"), nb::arg("limit") = 0,
+      nb::arg("offset") = 0);
+
+  m.def(
+      "compile_simple_values_filter",
+      [](std::uint32_t model_id, int dialect, nb::sequence field_names,
+         const std::string& lookup_field, bool lookup_in,
+         nb::sequence lookup_values, nb::sequence ordering_names,
+         std::uint64_t limit, std::uint64_t offset,
+         nb::handle postgres_integer_types) -> nb::object {
+        auto fields = strings_from_sequence(field_names);
+        auto ordering = strings_from_sequence(ordering_names);
+        const auto* model = registered_model(model_id);
+        const std::size_t value_count = nb::len(lookup_values);
+        auto prepared = model ? native_lookup_values_from_python(
+                                    *model, lookup_field, lookup_in,
+                                    lookup_values)
+                              : std::nullopt;
+        if (!model || !validate_native_projection(*model, fields) ||
+            !validate_native_ordering(*model, ordering) || !prepared ||
+            value_count == 0 || (!lookup_in && value_count != 1)) {
+          return nb::none();
+        }
+        std::string lookup_key = lookup_field;
+        lookup_key += lookup_in ? "__in#" : "__exact#";
+        lookup_key += std::to_string(value_count);
+        const auto key = simple_compile_key(
+            'F', model_id, dialect, fields, lookup_key, ordering, limit, offset);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.values(fields, true, django::orm::ResultMode::ValuesList)) {
+            return std::string{};
+          }
+          bool filtered = false;
+          if (lookup_in) {
+            std::vector<django::orm::ParamValue> values;
+            values.reserve(value_count);
+            for (std::size_t i = 0; i < value_count; ++i) {
+              values.push_back(django::orm::ParamValue::from_int(0));
+            }
+            filtered = qs.filter_in(lookup_field, std::move(values));
+          } else {
+            filtered = qs.filter_eq(lookup_field,
+                                    django::orm::ParamValue::from_int(0));
+          }
+          if (!filtered) {
+            return std::string{};
+          }
+          for (const auto& item : ordering) {
+            const bool desc = !item.empty() && item.front() == '-';
+            std::string_view name(item);
+            if (desc) {
+              name.remove_prefix(1);
+            }
+            if (name.empty() || name == "?" || !qs.order_by(name, desc)) {
+              return std::string{};
+            }
+          }
+          if (limit > 0) {
+            qs.set_limit(limit);
+          }
+          if (offset > 0) {
+            qs.set_offset(offset);
+          }
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        nb::list params;
+        for (const auto& value : *prepared) {
+          params.append(param_to_python(value, postgres_integer_types));
+        }
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), params);
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("field_names"),
+      nb::arg("lookup_field"), nb::arg("lookup_in"),
+      nb::arg("lookup_values"), nb::arg("ordering_names") = nb::tuple(),
+      nb::arg("limit") = 0, nb::arg("offset") = 0,
+      nb::arg("postgres_integer_types") = nb::none());
+
+  m.def(
+      "compile_simple_values_plan",
+      [](std::uint32_t model_id, int dialect,
+         const django::orm::QueryPlan& plan, std::uint64_t limit,
+         std::uint64_t offset,
+         nb::handle postgres_integer_types) -> nb::object {
+        auto shape = plan.simple_values_shape();
+        if (!shape || !plan.matches_model(
+                          static_cast<django::orm::ModelId>(model_id))) {
+          return nb::none();
+        }
+        std::string lookup_key = shape->lookup_field;
+        lookup_key += shape->lookup_in ? "__in#" : "__exact#";
+        lookup_key += std::to_string(shape->lookup_values->size());
+        const auto key = simple_compile_key(
+            'F', model_id, dialect, shape->fields, lookup_key,
+            shape->ordering, limit, offset);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.values(shape->fields, true,
+                         django::orm::ResultMode::ValuesList)) {
+            return std::string{};
+          }
+          bool filtered = false;
+          if (shape->lookup_in) {
+            std::vector<django::orm::ParamValue> values;
+            values.reserve(shape->lookup_values->size());
+            for (std::size_t i = 0; i < shape->lookup_values->size(); ++i) {
+              values.push_back(django::orm::ParamValue::from_int(0));
+            }
+            filtered = qs.filter_in(shape->lookup_field, std::move(values));
+          } else {
+            filtered = qs.filter_eq(shape->lookup_field,
+                                    django::orm::ParamValue::from_int(0));
+          }
+          if (!filtered) {
+            return std::string{};
+          }
+          for (const auto& item : shape->ordering) {
+            const bool desc = !item.empty() && item.front() == '-';
+            std::string_view name(item);
+            if (desc) {
+              name.remove_prefix(1);
+            }
+            if (name.empty() || name == "?" || !qs.order_by(name, desc)) {
+              return std::string{};
+            }
+          }
+          if (limit > 0) {
+            qs.set_limit(limit);
+          }
+          if (offset > 0) {
+            qs.set_offset(offset);
+          }
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        nb::list params;
+        for (const auto& value : *shape->lookup_values) {
+          params.append(param_to_python(value, postgres_integer_types));
+        }
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), params);
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("plan"),
+      nb::arg("limit") = 0, nb::arg("offset") = 0,
+      nb::arg("postgres_integer_types") = nb::none());
+
+  m.def(
+      "compile_simple_update",
+      [](std::uint32_t model_id, int dialect,
+         const std::string& lookup_field, nb::handle lookup_value,
+         nb::sequence update_names, nb::sequence update_values,
+         nb::handle postgres_integer_types) -> nb::object {
+        auto fields = strings_from_sequence(update_names);
+        const auto* model = registered_model(model_id);
+        auto lookup = model
+                          ? registered_native_lookup(*model, lookup_field)
+                          : std::optional<NativeLookup>{};
+        auto prepared_lookup = lookup
+                                   ? direct_param_from_python(
+                                         lookup_value, *lookup->field)
+                                   : std::nullopt;
+        auto updates = model ? native_updates_from_python(
+                                   *model, fields, update_values)
+                             : std::nullopt;
+        if (!model || !lookup || lookup->lookup != "exact" ||
+            !prepared_lookup || !updates) {
+          return nb::none();
+        }
+        const auto cache_fields = update_cache_fields(*updates);
+        const auto key = simple_compile_key(
+            'U', model_id, dialect, cache_fields, lookup_field, {}, 0, 0);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.filter_eq(lookup_field,
+                            django::orm::ParamValue::from_int(0))) {
+            return std::string{};
+          }
+          for (const auto& update : *updates) {
+            const bool added =
+                update.set_null
+                    ? qs.add_update_null(update.name)
+                    : qs.add_update(
+                          update.name,
+                          django::orm::ParamValue::from_int(0));
+            if (!added) {
+              return std::string{};
+            }
+          }
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        nb::list params;
+        for (const auto& update : *updates) {
+          if (!update.set_null) {
+            params.append(
+                param_to_python(update.value, postgres_integer_types));
+          }
+        }
+        params.append(
+            param_to_python(*prepared_lookup, postgres_integer_types));
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), params);
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("lookup_field"),
+      nb::arg("lookup_value"), nb::arg("update_names"),
+      nb::arg("update_values"),
+      nb::arg("postgres_integer_types") = nb::none());
+
+  m.def(
+      "compile_simple_update_plan",
+      [](std::uint32_t model_id, int dialect,
+         const django::orm::QueryPlan& plan, nb::dict raw_updates,
+         nb::handle postgres_integer_types) -> nb::object {
+        auto shape = plan.simple_update_shape();
+        const auto* model = registered_model(model_id);
+        auto updates = model
+                           ? native_updates_from_python(*model, raw_updates)
+                           : std::nullopt;
+        if (!shape || !model || !updates ||
+            !plan.matches_model(
+                static_cast<django::orm::ModelId>(model_id))) {
+          return nb::none();
+        }
+        const auto cache_fields = update_cache_fields(*updates);
+        const auto key = simple_compile_key(
+            'U', model_id, dialect, cache_fields, shape->lookup_field, {}, 0, 0);
+        auto sql = cached_simple_sql(key, [&]() {
+          django::orm::QuerySet qs(
+              static_cast<django::orm::ModelId>(model_id),
+              static_cast<django::orm::DialectId>(dialect));
+          if (!qs.filter_eq(shape->lookup_field,
+                            django::orm::ParamValue::from_int(0))) {
+            return std::string{};
+          }
+          for (const auto& update : *updates) {
+            const bool added =
+                update.set_null
+                    ? qs.add_update_null(update.name)
+                    : qs.add_update(
+                          update.name,
+                          django::orm::ParamValue::from_int(0));
+            if (!added) {
+              return std::string{};
+            }
+          }
+          return qs.compile().sql;
+        });
+        if (sql.empty()) {
+          return nb::none();
+        }
+        nb::list params;
+        for (const auto& update : *updates) {
+          if (!update.set_null) {
+            params.append(
+                param_to_python(update.value, postgres_integer_types));
+          }
+        }
+        params.append(
+            param_to_python(*shape->lookup_value, postgres_integer_types));
+        return nb::make_tuple(nb::str(sql.c_str(), sql.size()), params);
+      },
+      nb::arg("model_id"), nb::arg("dialect"), nb::arg("plan"),
+      nb::arg("updates"),
+      nb::arg("postgres_integer_types") = nb::none());
+
   nb::class_<django::orm::QuerySet>(m, "QuerySet")
       .def(nb::init<>())
       .def_static(
@@ -218,7 +1361,39 @@ void register_orm_engine(nb::module_& parent) {
                 static_cast<django::orm::DialectId>(dialect));
           },
           nb::arg("model_id"), nb::arg("dialect") = 0)
+      .def_static(
+          "create_from_q",
+          [](std::uint32_t model_id, int dialect, nb::dict tree) -> nb::object {
+            django::orm::QuerySet qs(
+                static_cast<django::orm::ModelId>(model_id),
+                static_cast<django::orm::DialectId>(dialect));
+            if (!qs.apply_q(q_node_from_python(tree))) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("model_id"), nb::arg("dialect"), nb::arg("tree"))
+      .def_static(
+          "create_from_native_q",
+          [](std::uint32_t model_id, int dialect,
+             nb::dict tree) -> nb::object {
+            auto node = native_q_node_from_python(model_id, tree);
+            if (!node) {
+              return nb::none();
+            }
+            django::orm::QuerySet qs(
+                static_cast<django::orm::ModelId>(model_id),
+                static_cast<django::orm::DialectId>(dialect));
+            if (!qs.apply_q(*node)) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("model_id"), nb::arg("dialect"), nb::arg("tree"))
       .def("clone", &django::orm::QuerySet::clone)
+      .def("shares_state_with", &django::orm::QuerySet::shares_state_with,
+           nb::arg("other"))
+      .def("compile_runs", &django::orm::QuerySet::compile_runs)
       .def(
           "filter_eq",
           [](django::orm::QuerySet& self, const std::string& field,
@@ -280,6 +1455,33 @@ void register_orm_engine(nb::module_& parent) {
           },
           nb::arg("tree"),
           "Apply a full Q-tree dict (and/or/not/xor/atom) in C++.")
+      .def(
+          "with_q",
+          [](const django::orm::QuerySet& self, nb::dict tree) -> nb::object {
+            django::orm::QuerySet qs = self.clone();
+            if (!qs.apply_q(q_node_from_python(tree))) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("tree"),
+          "Return a COW clone with a Q-tree applied.")
+      .def(
+          "with_native_q",
+          [](const django::orm::QuerySet& self,
+             nb::dict tree) -> nb::object {
+            auto node = native_q_node_from_python(self.model_id(), tree);
+            if (!node) {
+              return nb::none();
+            }
+            django::orm::QuerySet qs = self.clone();
+            if (!qs.apply_q(*node)) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("tree"),
+          "Return a COW clone with a schema-validated primitive Q-tree.")
       .def(
           "filter_subquery",
           [](django::orm::QuerySet& self, const std::string& field, int op,
@@ -304,6 +1506,20 @@ void register_orm_engine(nb::module_& parent) {
             return self.values(ns, true, mode);
           },
           nb::arg("names"), nb::arg("flat") = false)
+      .def(
+          "with_values_list",
+          [](const django::orm::QuerySet& self, nb::sequence names,
+             bool flat) -> nb::object {
+            django::orm::QuerySet qs = self.clone();
+            auto ns = strings_from_sequence(names);
+            auto mode = flat ? django::orm::ResultMode::ValuesListFlat
+                             : django::orm::ResultMode::ValuesList;
+            if (!qs.values(ns, true, mode)) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("names"), nb::arg("flat") = false)
       .def(
           "values",
           [](django::orm::QuerySet& self, nb::sequence names) {
@@ -314,6 +1530,18 @@ void register_orm_engine(nb::module_& parent) {
             return self.values(ns, true, django::orm::ResultMode::ValuesDict);
           },
           nb::arg("names"))
+      .def(
+          "with_values",
+          [](const django::orm::QuerySet& self,
+             nb::sequence names) -> nb::object {
+            django::orm::QuerySet qs = self.clone();
+            auto ns = strings_from_sequence(names);
+            if (!qs.values(ns, true, django::orm::ResultMode::ValuesDict)) {
+              return nb::none();
+            }
+            return nb::cast(std::move(qs));
+          },
+          nb::arg("names"))
       .def("clear_select", &django::orm::QuerySet::clear_select)
       .def("select_model_columns", &django::orm::QuerySet::select_model_columns)
       .def(
